; Author: William B. Brogden  8/31/90
;
; simple user primitive example from ACTOR manual
;     adapted to string translation
; method will go in the string class,  format will be
;  xform(self, aStruct ) where the struct is 256 bytes long
;     and has a replacement for each possible character
; string can be asciiz terminated,  return ALTERED self
;
.XLIST
include userprim.inc
.LIST

code    segment word 'CODE'
        assume cs:code
aPrim   proc    near
        pop     bx              ; get receiver OP (string)
        pop     cx              ; OP for struct
        cld       ; auto increment
;  bx = string OP, cx = xlate struct OP
       push es   ; preserve
       push dx   ; for return
       push si   ; to calling method
       push di
       push bx   ; string OP for return 
;  reg required for return are CS, SS, ES, DX, SI, BP
       mov  dx,cx         ; now use dx for struct OP
       addrOP  bx,si      ; ds:si = string data
       getSize bx,si,cx   ; see ACTOR manual p706 example, cx = string count
       push    cx
       push    ds
       push    si         ; save
       mov     bx,dx      ; xlate struct OP
       addrOP  bx,si      ; ds:si = struct start
       pop     di
       pop     es
       pop     cx         ; es:di = string data cx = count 
; we can now use any register except stack ones , I think
       or      cx,cx
       jz      exit     ; 0 length string
       xor     bx,bx    ; ensure bh = 0 
xla0:  mov bl,es:[di]   ; char from string
       mov al,[si+bx]   ; xlated char from struc, ds implied
       stosb            ; al -> es:di, inc di
       loop   xla0      ; till cx = 0 
; if here, end of string
exit:  pop ax    ; string OP
       pop di
       pop si
       pop dx
       pop es 
       exitPrim ax      ; leave return stringOP on stack
aPrim  endp
code   ends
       end
